//------------------------------------------------
//     AMPIRE 162D |
//   2-       |
//            HITACHI                |
//         IAR C  1.40            |
//    HISTAR 8515\8535 |       
//    .A 12.01.2001  alex_shipov@mail.ru    |
//                 "HISTAR"                  |
//       http://www.chat.ru/~histarcorp           | 
//------------------------------------------------
//    HISTAR 8515
//    16
// 1- gnd(1)            5-D4(11)
// 2- +5v(2)            6-D5(12)
// 3- RS (4)            7-D6(13)
// 4- EN (6)            8-D7(14)
//  gnd(1) ,R/W(5),V0(3) e

#include "defs.h"
#include "vars.h"
#include "delay.h"
/*********************************/
/*      Display  HD44780         */
/*********************************/
 unsigned char CharToCode ( unsigned char C )
{
   switch ( C )
      {//    
                    //RUS
          
   
         case '' : return ('A');
         case '' : return ('a');
         case '' : return ( 0xA0 );
         case '' : return ( 0xB2 );
         case '' : return ('B');
         case '' : return (0xB3);
         case '' : return ( 0xA1 );
         case '' : return ( 0xB4 );
         case '' : return ( 0xe0 );
         case '' : return ( 0xe3 );
         case '' : return ( 0x45 );
         case '' : return ( 'e');
         case '' : return ( 0xA3 );
         case '' : return ( 0xb6 );
         case '' : return ( 0xa4 );
         case '' : return ( 0xb7 );
         case '' : return ( 0xa5 );
         case '' : return ( 0xb8 );
         case '' : return ( 0xa6 );
         case '' : return ( 0xb9 );
         case '' : return ('K');
         case '' : return (0xba);
         case '' : return ( 0xa7 );
         case '' : return ( 0xbb );
         case '' : return ('M');
         case '' : return (0xbc);
         case '' : return ('H');
         case '' : return (0xbd);
         case '' : return ('O');
         case '' : return ('o');
         case '' : return ( 0xa8 );
         case '' : return ( 0xbe );
         case '' : return ('P');
         case '' : return ('p');
         case '' : return ('C');
         case '' : return ('c');
         case '' : return ('T');
         case '' : return (0xbf);
         case '' : return ( 0xA9 );
         case '' : return ( 'y');
         case '' : return ( 0xaa );
         case '' : return ( 0xE4 );
         case '' : return ('X');
         case '' : return ('x');
         case '' : return ( 0xE1 );
         case '' : return ( 0xE5 );
         case '' : return ( 0xab );
         case '' : return ( 0xC0 );
         case '' : return ( 0xac );
         case '' : return ( 0xC1 );
         case '' : return ( 0xE2 );
         case '' : return ( 0xE6 );
         case '' : return ( 0xad );
         case '' : return ( 0xC2 );
         case '' : return ( 0xAE );
         case '' : return ( 0xC3 );
         case '' : return ( 'b' );
         case '' : return ( 0xC4 );
         case '' : return ( 0xaf );
         case '' : return ( 0xC5 );
         case '' : return ( 0xb0 );
         case '' : return ( 0xC6 );
         case '' : return ( 0xb1 );
         case '' : return ( 0xC7 );

                     
               }
   return ( 0x80 );
} // CharToCode 

//------------------------------------
unsigned char DigToChar ( unsigned char C )
{
   return ( C + 0x30 );
} // DigToChar 

//------------------------------------
void LCDWrite ( unsigned char c )
{ //      P1
   unsigned char t;
       
    t=c&0xF0;
    t=t|(PINB&0x0F);   
    LCDAddr =  t;
    LCD_STROBE;
    c=(c<<4)&0xF0;
    c=c|(PINB&0x0F);
    LCDAddr = c ;
    LCD_STROBE;
    DelayUs (80 );
    
} // LCDWrite  
//-------------------------------------
void LCDClear (void)
{
   LCD_RSOFF;// = 0;
   LCDWrite ( 0x01 );
   DelayMs ( 5 );
} // LCDClear
//-------------------------------------
void LCDPutCh ( char c )
{
   LCD_RSON;// = 1;
   LCDWrite ( c );   
} // LCDPutCh 

//-------------------------------------
void LCDPutChR ( char c )
{
   LCD_RSON;// = 1;
   LCDWrite (CharToCode(c) );   
} // LCDPutChR 

//-------------------------------------
void LCDPutS ( const char * s )
{
   while ( *s ) LCDPutCh ( *s++ );
} // LCDPutS 

//-------------------------------------
void LCDPutSR ( const char * s )
{
   while ( *s ) LCDPutCh(CharToCode ( *s++ ));
} /* LCDPutSR */
//-------------------------------------
void LCDPutCd ( char c )
{
   LCD_RSOFF;// = 0;
   LCDWrite ( c );   
} // LCDPutCh 

//-------------------------------------
void LCDGoto ( unsigned char pos )
{
   LCDPutCd ( 0x80 + pos );
} /* LCDGoto */
//-------------------------------------
void LCDInit (void)
{
   DelayMs ( 80 );LCDPutCd ( 0x03 );DelayMs ( 10 );LCDPutCd ( 0x03 );
   DelayUs ( 250 );LCDPutCd ( 0x03 );DelayMs ( 40 );LCDPutCd ( 0x02 );
   DelayUs ( 250 );
   LCDPutCd ( 0x28 ); // 4 bit mode, 1/16 duty, 5x8 font 
   LCDPutCd ( 0x08 ); // display off 
   LCDPutCd ( 0x0F ); // display on, blink curson on 
   LCDPutCd ( 0x0c );// 0-   06-   entry mode 
   } // LCDInit 





